unit DBBuilder.Actions.Core;

interface

uses
  System.Classes, System.SysUtils;

type
  EActionError = class(Exception);

  IAction = interface
    ['{65FD8287-937D-4978-8084-17250EF12146}']
    procedure ExecuteFile(const LFileName: string);
  end;

  TAction = class
  public
    class procedure ExecuteFile(const AFileName: string);
  end;

implementation

{ TAction }

uses
  Dynamo.Core.ServiceLocator;

class procedure TAction.ExecuteFile(const AFileName: string);
var
  LFileExt: string;
  LAction: IAction;
begin
  LFileExt := ExtractFileExt(AFileName).Substring(1).ToUpper;
  LAction := ServiceLocator.GetClass<IAction>(LFileExt);
  LAction.ExecuteFile(AFileName);
end;

end.
