unit DBBuilder.Actions.CustomScript;

interface

uses
  System.Classes, System.SysUtils, System.IOUtils,
  DBBuilder.Actions.Core, Dynamo.Core.Rtti;

type
  [Alias('ISC')]
  TCustomScriptAction = class(TInterfacedObject, IAction)
  public
    procedure ExecuteFile(const LFileName: string);
  end;

implementation

{ TCustomScript }

uses
  DBBuilder.Core.Config, DBBuilder.DB.DatabaseManager,
  Dynamo.Core.ServiceLocator,
  DBBuilder.ISCScript.Interpreter, DBBuilder.ISCScript.Processor;

procedure TCustomScriptAction.ExecuteFile(const LFileName: string);
var
  LFilePath: string;
  LRunner: TRunner;
begin
  DefaultScriptProcessor.DefaultConnection := TargetDatabaseManager;
  LFilePath := TPath.Combine(Config.ScriptPath, LFileName);

  LRunner := TRunner.Create(LFilePath, DefaultScriptProcessor);
  try
    LRunner.Execute;
  finally
    LRunner.Free;
  end;
end;

initialization

  ServiceLocator.RegisterClass(TCustomScriptAction);

end.
