unit DBBuilder.Actions.SQL;

interface

uses
  System.Classes, System.SysUtils, System.IOUtils,
  DBBuilder.Actions.Core, Dynamo.Core.Rtti;

type
  [Alias('SQL')]
  TSQLAction = class(TInterfacedObject, IAction)
  public
    procedure ExecuteFile(const LFileName: string);
  end;

implementation

{ TSQLAction }

uses
  DBBuilder.Core.Config, DBBuilder.DB.DatabaseManager,
  Dynamo.Core.ServiceLocator;

procedure TSQLAction.ExecuteFile(const LFileName: string);
var
  LScript: string;
  LFilePath: string;
begin
  LFilePath := TPath.Combine(Config.ScriptPath, LFileName);
  LScript := TFile.ReadAllText(LFilePath);
  TargetDatabaseManager.ExecuteScript(LScript);
  TargetDatabaseManager.Commit;
  TargetDatabaseManager.LoadScriptTable;
end;

initialization

  ServiceLocator.RegisterClass(TSQLAction);

end.
