unit DBBuilder.DB.DatabaseEngine;

interface

uses
  System.Classes, System.SysUtils, Data.DB, DBBuilder.Core.Config,
  DBBuilder.DB.Core;

type
  EDatabaseEngineError = class(Exception)
  end;

  IDatabaseEngine = interface
  ['{7B6AA6DE-11ED-4954-B989-11DB04C8DB9C}']
    function DateTimeToDBStr(ADateTime: TDateTime): string;
    function DateToDBStr(ADateTime: TDateTime): string;
    function QuoteValue(AValue: Variant; AFieldType: TFieldType): string;
    procedure ExecuteScript(const AStatement: string);
    procedure ExecuteStatement(const AScript: string; AParams: TDBParams);
    function CheckTable(const ATableName: string): Boolean;
    function CreateDataSet(const ASQL: string): TDataSet;
    function GetConnect: Boolean;
    procedure SetSequence(const ASequenceName: string; AValue: Int64);
    procedure AlterTriggerStatus(const ATriggerName: string; ATriggerStatus: TTriggerStatus);
    function GetAllTriggers: TArray<string>;
    procedure Commit;
    procedure Rollback;
    procedure Connect(ADatabase: TDatabaseInfo);
    procedure Disconnect;

    property Connected: Boolean read GetConnect;
  end;

implementation

end.
